"{ Package: 'stx:goodies/xtreams/support' }"

"{ NameSpace: Xtreams }"

ByteArray variableByteSubclass:#InterpretedBytes
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Xtreams-Support'
!


!InterpretedBytes class methodsFor:'instance creation'!

withSize: anInteger
	^self new: anInteger
! !

!InterpretedBytes class methodsFor:'type descriptions'!

char

	^(Array with: 1 with: ByteArray with: [:b :i | b byteAt: i] with: [:b :i :o | b byteAt: i put: o])
!

double

	^(Array with: 8 with: "DoubleArray" Array with: [:b :i | b doubleAt: i] with: [:b :i :o | b doubleAt: i put: o])
!

double_be

	self isBigEndian ifTrue: [ ^self double ].
	^(Array with: 8 with: "DoubleArray" Array with: [:b :i | b doubleAt: i bigEndian: true] with: [:b :i :o | b doubleAt: i put: o bigEndian: true])
!

double_le

	self isBigEndian ifFalse: [ ^self double ].
	^(Array with: 8 with: "DoubleArray" Array with: [:b :i | b doubleAt: i bigEndian: false] with: [:b :i :o | b doubleAt: i put: o bigEndian: false])
!

float

	^(Array with: 4 with: "FloatArray" Array with: [:b :i | b floatAt: i] with: [:b :i :o | b floatAt: i put: o])
!

float_be

	self isBigEndian ifTrue: [ ^self float ].
	^(Array with: 4 with: "FloatArray" Array with: [:b :i | b floatAt: i bigEndian: true] with: [:b :i :o | b floatAt: i put: o bigEndian: true])
!

float_le

	self isBigEndian ifFalse: [ ^self float ].
	^(Array with: 4 with: "FloatArray" Array with: [:b :i | b floatAt: i bigEndian: false] with: [:b :i :o | b floatAt: i put: o bigEndian: false])
!

long

        ^(Array with: 4 with: "DwordArray" IntegerArray with: [:b :i | b unsignedLongAt: i] with: [:b :i :o | b unsignedLongAt: i put: o])
!

long_be

        self isBigEndian ifTrue: [ ^self long ].
        ^(Array with: 4 with: "DwordArray" IntegerArray with: [:b :i | b unsignedLongAt: i bigEndian: true ] with: [:b :i :o | b unsignedLongAt: i put: o bigEndian: true])
!

long_le

        self isBigEndian ifFalse: [ ^self long ].
        ^(Array with: 4 with: "DwordArray" IntegerArray  with: [:b :i | b unsignedLongAt: i bigEndian: false ] with: [:b :i :o | b unsignedLongAt: i put: o bigEndian: false])
!

longlong

        ^(Array with: 8 with: LongIntegerArray with: [:b :i | b unsignedLongLongAt: i bigEndian:(UninterpretedBytes isBigEndian)] with: [:b :i :o | b unsignedLongLongAt: i put: o bigEndian:(UninterpretedBytes isBigEndian)])
!

longlong_be

        self isBigEndian ifTrue: [ ^self longlong ].
        ^(Array with: 8 with: LongIntegerArray with: [:b :i | b unsignedLongLongAt: i bigEndian: true] with: [:b :i :o | b unsignedLongLongAt: i put: o bigEndian: true])
!

longlong_le

        self isBigEndian ifFalse: [ ^self longlong ].
        ^(Array with: 8 with: LongIntegerArray with: [:b :i | b unsignedLongLongAt: i bigEndian: false] with: [:b :i :o | b unsignedLongLongAt: i put: o bigEndian: false])
!

short

	^Array with: 2 with: WordArray with: [:b :i | b unsignedShortAt: i] with: [:b :i :o | b unsignedShortAt: i put: o]
!

short_be

	self isBigEndian ifTrue: [ ^self short ].
	^Array with: 2 with: WordArray with: [:b :i | b unsignedShortAt: i bigEndian: true ] with: [:b :i :o | b unsignedShortAt: i put: o bigEndian: true ]
!

short_le

	self isBigEndian ifFalse: [ ^self short ].
	^Array with: 2 with: WordArray with: [:b :i | b unsignedShortAt: i bigEndian: false ] with: [:b :i :o | b unsignedShortAt: i put: o bigEndian: false ]
!

signedChar

	^(Array with: 1 with: Array with: [:b :i | b signedByteAt: i] with: [:b :i :o | b signedByteAt: i put: o])
!

signedLong

        ^(Array with: 4 with: SignedIntegerArray with: [:b :i | b longAt: i] with: [:b :i :o | b longAt: i put: o])
!

signedLong_be

        self isBigEndian ifTrue: [ ^self signedLong ].
        ^(Array with: 4 with: SignedIntegerArray with: [:b :i | b longAt: i bigEndian: true ] with: [:b :i :o | b longAt: i put: o bigEndian: true])
!

signedLong_le

        self isBigEndian ifFalse: [ ^self signedLong ].
        ^(Array with: 4 with: SignedIntegerArray with: [:b :i | b longAt: i bigEndian: false ] with: [:b :i :o | b longAt: i put: o bigEndian: false])
!

signedLonglong

        ^(Array with: 8 with: SignedLongIntegerArray with: [:b :i | b longLongAt: i] with: [:b :i :o | b longLongAt: i put: o])
!

signedLonglong_be

        self isBigEndian ifTrue: [ ^self signedLonglong ].
        ^(Array with: 8 with: SignedLongIntegerArray with: [:b :i | b longLongAt: i bigEndian: true] with: [:b :i :o | b longLongAt: i put: o bigEndian: true])
!

signedLonglong_le

        self isBigEndian ifFalse: [ ^self signedLonglong ].
        ^(Array with: 8 with: SignedLongIntegerArray with: [:b :i | b longLongAt: i bigEndian: false] with: [:b :i :o | b longLongAt: i put: o bigEndian: false])
!

signedShort

        ^(Array with: 2 with: SignedWordArray with: [:b :i | b shortAt: i] with: [:b :i :o | b shortAt: i put: o])
!

signedShort_be

        self isBigEndian ifTrue: [ ^self signedShort ].
        ^Array with: 2 with: SignedWordArray with: [:b :i | b shortAt: i bigEndian: true ] with: [:b :i :o | b shortAt: i put: o bigEndian: true ]
!

signedShort_le

        self isBigEndian ifFalse: [ ^self signedShort ].
        ^Array with: 2 with: SignedWordArray with: [:b :i | b shortAt: i bigEndian: false ] with: [:b :i :o | b shortAt: i put: o bigEndian: false ]
!

tlsUint24

	^Array
		with: 3
		with: Array
		with: [ :b :i | ((((b byteAt: i) bitShift: 8) + (b byteAt: i + 1)) bitShift: 8) + (b byteAt: i + 2) ]
		with: [ :b :i :o |
			b       byteAt: i put: (o bitShift: -16);
				byteAt: i + 1 put: ((o bitShift: -8) bitAnd: 255);
				byteAt: i + 2 put: (o bitAnd: 255) ]
!

unsignedChar

	^(Array with: 1 with: ByteArray with: [:b :i | b byteAt: i] with: [:b :i :o | b byteAt: i put: o])
!

unsignedLong

        ^(Array with: 4 with: "DwordArray" IntegerArray with: [:b :i | b unsignedLongAt: i] with: [:b :i :o | b unsignedLongAt: i put: o])
!

unsignedLong_be

        self isBigEndian ifTrue: [ ^self unsignedLong ].
        ^(Array with: 4 with: "DwordArray" IntegerArray with: [:b :i | b unsignedLongAt: i bigEndian: true ] with: [:b :i :o | b unsignedLongAt: i put: o bigEndian: true])
!

unsignedLong_le

        self isBigEndian ifFalse: [ ^self unsignedLong ].
        ^(Array with: 4 with: "DwordArray" IntegerArray with: [:b :i | b unsignedLongAt: i bigEndian: false ] with: [:b :i :o | b unsignedLongAt: i put: o bigEndian: false])
!

unsignedLonglong

        ^(Array with: 8 with: LongIntegerArray with: [:b :i | b unsignedLongLongAt: i] with: [:b :i :o | b unsignedLongLongAt: i put: o])
!

unsignedLonglong_be

        self isBigEndian ifTrue: [ ^self unsignedLonglong ].
        ^(Array with: 8 with: LongIntegerArray with: [:b :i | b unsignedLongLongAt: i bigEndian: true] with: [:b :i :o | b unsignedLongLongAt: i put: o bigEndian: true])
!

unsignedLonglong_le

        self isBigEndian ifFalse: [ ^self unsignedLonglong ].
        ^(Array with: 8 with: LongIntegerArray with: [:b :i | b unsignedLongLongAt: i bigEndian: false] with: [:b :i :o | b unsignedLongLongAt: i put: o bigEndian: false])
!

unsignedShort

	^Array with: 2 with: WordArray with: [:b :i | b unsignedShortAt: i] with: [:b :i :o | b unsignedShortAt: i put: o]
!

unsignedShort_be

	self isBigEndian ifTrue: [ ^self unsignedShort ].
	^Array with: 2 with: WordArray with: [:b :i | b unsignedShortAt: i bigEndian: true ] with: [:b :i :o | b unsignedShortAt: i put: o bigEndian: true ]
!

unsignedShort_le

	self isBigEndian ifFalse: [ ^self unsignedShort ].
	^Array with: 2 with: WordArray with: [:b :i | b unsignedShortAt: i bigEndian: false ] with: [:b :i :o | b unsignedShortAt: i put: o bigEndian: false ]
! !

!InterpretedBytes class methodsFor:'xtreams'!

newInFixedSpaceRecycled: size

	^RecyclingCenter newInFixedSpace: size class: self
!

newInFixedSpaceRecycledDefaultSize

	^self newInFixedSpaceRecycled: DefaultBufferSize
!

newRecycled: size

	^RecyclingCenter new: size class: self
!

newRecycledDefaultSize

	^self newRecycled: DefaultBufferSize
! !

!InterpretedBytes methodsFor:'accessing'!

recycle

        RecyclingCenter recycle: self
! !

!InterpretedBytes class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !
