"{ Package: 'stx:goodies/xtreams/transforms/tests' }"

"{ NameSpace: Xtreams }"

TestCase subclass:#DuplicateTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Xtreams-Transforms-Tests'
!


!DuplicateTest methodsFor:'tests'!

testDuplicateReading
        | copy |
        copy := Array new writing.
        self assert: (((0 to: 255) reading duplicating: copy) rest isSameSequenceAs: copy conclusion)
!

testDuplicateReadingIncomplete
	| original copy |
	copy := ByteArray new writing.
	[(#[0 1 2 3 4 5 6 7 8 9] reading duplicating: copy) read: 20] on: Incomplete do: [:incomplete | original := incomplete contents].
	copy := copy conclusion.
	self assert: original = #[0 1 2 3 4 5 6 7 8 9].
	self assert: copy = #[0 1 2 3 4 5 6 7 8 9]
!

testDuplicateWriting
	| original copy |
	original := ByteArray new writing.
	copy := ByteArray new writing.
	(original duplicating: copy) write: (0 to: 255).
	self assert: original conclusion = copy conclusion
!

testDuplicateWritingIncomplete
	| original copy |
	original := ByteArray new writing.
	copy := ByteArray new writing.
	[((original limiting: 10) duplicating: copy) write: (0 to: 255)] on: Incomplete do: [:incomplete | ].
	original := original conclusion.
	copy := copy conclusion.
	self assert: original = #[0 1 2 3 4 5 6 7 8 9].
	self assert: copy = #[0 1 2 3 4 5 6 7 8 9]
! !

!DuplicateTest class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !
